︠436d73f2-8e2e-46ff-81aa-aece55aec4fds︠
load("func_graphs.sage")
from sage.graphs.spanning_tree import kruskal

# small local function to print weight of tree
n = 400
for i in range(1, 10):

    # generate a random graph that is SPARSE
    # probability .6
    gg = random_weighted_graph(n, .5, 1, 100)
    num_edges = gg.size()
    # call kruskal's algorithm, and record the time
    t_init = cputime(subprocesses=True)
    E = kruskal(gg);
    w = print_tree_weight(E)
    t_final = cputime(subprocesses=True) - t_init
    print "1 Kruskal " + str(n) + " vertices, edges = " + str(num_edges) + ", weight = " + str(w) + ", time = " + str(t_final)


    # generate a random graph that is DENSE
    # probability .8
    gg = random_weighted_graph(n, .8, 1, 100)
    num_edges = gg.size()
    # call kruskal's algorithm, and record the time
    t_init = cputime(subprocesses=True)
    E = kruskal(gg);
    w = print_tree_weight(E)
    t_final = cputime(subprocesses=True) - t_init
    print "1 Kruskal " + str(n) + " vertices, edges = " + str(num_edges) + ", weight = " + str(w) + ", time = " + str(t_final)




︡5b4ddc5f-7c60-4d84-9dcd-3d0a51fada63︡{"stdout":"1 Kruskal 400 vertices, edges = 39758, weight = 399, time = 0.064"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 63843, weight = 399, time = 0.104"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 39841, weight = 399, time = 0.064"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 63704, weight = 399, time = 0.112"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 39812, weight = 399, time = 0.064"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 63866, weight = 399, time = 0.108"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 40082, weight = 399, time = 0.064"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 63872, weight = 399, time = 0.104"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 39725, weight = 399, time = 0.068"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 63778, weight = 399, time = 0.104"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 39870, weight = 399, time = 0.068"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 63812, weight = 399, time = 0.116"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 39890, weight = 399, time = 0.068"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 63849, weight = 399, time = 0.112"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 39998, weight = 399, time = 0.064"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 64068, weight = 399, time = 0.108"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 39944, weight = 399, time = 0.064"}︡{"stdout":"\n1 Kruskal 400 vertices, edges = 63740, weight = 399, time = 0.124"}︡{"stdout":"\n"}︡{"done":true}︡
︠5e3ac381-851e-42b8-bb16-44c66eae315d︠
#
# input: an integer n
# output: n!
# example: my_factorial(3) = 6
def my_factorial(n):
    my_fac = 1;
    for i in range(2,n+1):
        print "my_fac = " + str(my_fac)
        my_fac = my_fac*i
    return my_fac
#end def

my_factorial(6)

︡af0c594f-7021-41a7-8443-39e2a9e0f56d︡{"stdout":"my_fac = 1\nmy_fac = 2\nmy_fac = 6\nmy_fac = 24\nmy_fac = 120\n720\n"}︡{"done":true}︡
︠8d7d92ac-6a1e-46fe-8eaa-ab0efb556f86s︠
import random

g = Graph([(0,1),(0,2),(1,2)])
g.show()
uw_edges = g.edges()
uw_edges
#   00 01 02      10 11 12
# [(0, 1, None), (0, 2, None), (1, 2, None)]
uw_edges[2][1]
uw_edges[2][0]

# number of edges
m = g.size()
m

w = random.randint(1,10)
# [(0, 1, None), (0, 2, None), (1, 2, None)]
w_edges = [(uw_edges[i][0], uw_edges[i][1], random.randint(1,10)) for i in range(0,m)]
w_edges

gg = Graph(w_edges, weighted=true)
gg.show(edge_labels=true)

from sage.graphs.spanning_tree import kruskal
E = kruskal(gg);
E
H = gg.subgraph(edges=E)
H.show(edge_labels=true)

w = E[0][2] + E[1][2]
print "tree weight = " + str(w)







︡65323b9c-198e-4eee-931f-c4b3f93b7fa7︡{"file":{"filename":"/home/user/.sage/temp/project-312b5dfd-a6ad-48f3-830b-d35eb199d477/502/tmp_biwxoI.svg","show":true,"text":null,"uuid":"f8563efc-e5da-4832-9675-c1df6aee7ece"},"once":false}︡{"stdout":"[(0, 1, None), (0, 2, None), (1, 2, None)]\n"}︡{"stdout":"2\n"}︡{"stdout":"1\n"}︡{"stdout":"3\n"}︡{"stdout":"[(0, 1, 3), (0, 2, 9), (1, 2, 3)]\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-312b5dfd-a6ad-48f3-830b-d35eb199d477/502/tmp_d05tt8.svg","show":true,"text":null,"uuid":"92efc271-705f-447b-8f06-6c70662e29f3"},"once":false}︡{"stdout":"[(0, 1, 3), (1, 2, 3)]\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-312b5dfd-a6ad-48f3-830b-d35eb199d477/502/tmp_2GvuNL.svg","show":true,"text":null,"uuid":"c8bf1032-4c4a-4ade-b6fc-20cab1e8d8ef"},"once":false}︡{"stdout":"tree weight = 6\n"}︡{"done":true}︡
︠326e0a52-e3e1-4af6-8bec-3c23ac6b0037︠
g = BipartiteGraph();
g.add_edges([(0,4),(0,5),(1,4),(1,7),(1,5),(1,6),(2,4),(3,4),(2,5),(3,5)]);
g.show()

︡19cf63ce-c34d-4a6f-a9e3-c6f5ade58133︡
︠ae635f4c-e93f-4c09-95ac-a7bd61141e22︠
A = Matrix([
        [1, 1, 1, 0, 0, 0, 0],# 0
        [0, 0, 0, 1, 0, 0, 0],# 1
        [0, 0, 0, 0, 1, 1, 1],# 2
        [1, 0, 0, 0, 1, 0, 0],# 3
        [0, 1, 0, 0, 0, 1, 0],# 4
        [0, 0, 1, 1, 0, 0, 1]# 5
        ]);
A

p = MixedIntegerLinearProgram(maximization=True, solver = "GLPK")
x = p.new_variable(integer=True, nonnegative=True)
p.add_constraint(x[0] + x[1] + x[2] <= 1) # row 0
p.add_constraint(x[3] <= 1) # row 1
p.add_constraint(x[4] + x[5] + x[6] <= 1) # row 2
p.add_constraint(x[0] + x[4] <= 1) # row 3
p.add_constraint(x[1] + x[5] <= 1) # row 4
p.add_constraint(x[2] + x[3] + x[6] <= 1) # row 5
p.set_objective(x[0] + x[1] + x[2] + x[3] + x[4] + x[5] + x[6])
p.show()
print('Objective Value: {}'.format(p.solve()))
for i, v in p.get_values(x).iteritems():
    print('x_%s = %s' % (i, int(round(v))))

# find the minimum cover
p = MixedIntegerLinearProgram(maximization=False, solver = "GLPK")
y = p.new_variable(integer=True, nonnegative=True)
p.add_constraint(y[0] + y[3] >= 1) # column 03
p.add_constraint(y[0] + y[4] >= 1) # column 04
p.add_constraint(y[0] + y[5] >= 1) # column 05
p.add_constraint(y[1] + y[5] >= 1) # column 15
p.add_constraint(y[2] + y[3] >= 1) # column 23
p.add_constraint(y[2] + y[4] >= 1) # column 24
p.add_constraint(y[2] + y[5] >= 1) # column 25
p.set_objective(y[0] + y[1] + y[2] + y[3] + y[4] + y[5])
p.show()
print('Objective Value: {}'.format(p.solve()))
for i, v in p.get_values(y).iteritems():
    print('x_%s = %s' % (i, int(round(v))))



︡b693f010-6461-4e47-a1c2-ea855f22d7c6︡{"stdout":"[1 1 1 0 0 0 0]\n[0 0 0 1 0 0 0]\n[0 0 0 0 1 1 1]\n[1 0 0 0 1 0 0]\n[0 1 0 0 0 1 0]\n[0 0 1 1 0 0 1]\n"}︡{"stdout":"Maximization:\n  x_0 + x_1 + x_2 + x_3 + x_4 + x_5 + x_6 \n\nConstraints:\n  x_0 + x_1 + x_2 <= 1.0\n  x_3 <= 1.0\n  x_4 + x_5 + x_6 <= 1.0\n  x_0 + x_4 <= 1.0\n  x_1 + x_5 <= 1.0\n  x_2 + x_3 + x_6 <= 1.0\nVariables:\n  x_0 is an integer variable (min=0.0, max=+oo)\n  x_1 is an integer variable (min=0.0, max=+oo)\n  x_2 is an integer variable (min=0.0, max=+oo)\n  x_3 is an integer variable (min=0.0, max=+oo)\n  x_4 is an integer variable (min=0.0, max=+oo)\n  x_5 is an integer variable (min=0.0, max=+oo)\n  x_6 is an integer variable (min=0.0, max=+oo)\n"}︡{"stdout":"Objective Value: 3.0\n"}︡{"stdout":"x_0 = 1\nx_1 = 0\nx_2 = 0\nx_3 = 1\nx_4 = 0\nx_5 = 1\nx_6 = 0\n"}︡{"stdout":"Minimization:\n  x_0 + x_1 + x_2 + x_3 + x_4 + x_5 \n\nConstraints:\n  - x_0 - x_1 <= -1.0\n  - x_0 - x_2 <= -1.0\n  - x_0 - x_3 <= -1.0\n  - x_3 - x_4 <= -1.0\n  - x_1 - x_5 <= -1.0\n  - x_2 - x_5 <= -1.0\n  - x_3 - x_5 <= -1.0\nVariables:\n  x_0 is an integer variable (min=0.0, max=+oo)\n  x_1 is an integer variable (min=0.0, max=+oo)\n  x_2 is an integer variable (min=0.0, max=+oo)\n  x_3 is an integer variable (min=0.0, max=+oo)\n  x_4 is an integer variable (min=0.0, max=+oo)\n  x_5 is an integer variable (min=0.0, max=+oo)\n"}︡{"stdout":"Objective Value: 3.0\n"}︡{"stdout":"x_0 = 1\nx_1 = 0\nx_2 = 1\nx_3 = 0\nx_4 = 0\nx_5 = 1\n"}︡{"done":true}︡
︠f57718e2-0ed7-465f-b572-09e2d4ebb0bc︠

g = Graph();
g.add_edges([(0,2),(0,3),(0,4),(1,2),(1,3),(1,4),(2,4),(3,4)]);
show(g)
#draw(g)
#P.show()

M = Matrix([(0,1,0,0,1,1,0,0,0,0),(1,0,1,0,0,0,1,0,0,0),
(0,1,0,1,0,0,0,1,0,0), (0,0,1,0,1,0,0,0,1,0),(1,0,0,1,0,0,0,0,0,1),
(1,0,0,0,0,0,0,1,1,0), (0,1,0,0,0,0,0,0,1,1),(0,0,1,0,0,1,0,0,0,1),
(0,0,0,1,0,1,1,0,0,0), (0,0,0,0,1,0,1,1,0,0)])
M
G = Graph(M);
G.plot()

# create the incidence matrix for a path
# edges (0,1),(0,2),(1,2),(0,3),(1,3)
# incidence matrix is 4 x 5
M = Matrix([
        (1,1,0,1,0), # vertex 0
        (1,0,1,0,1), # vertex 1
        (0,1,1,0,0), # vertex 2
        (0,0,0,1,1) # vertex 3
        ]);
M
g = Graph(M)
g.plot()

︡758da064-765c-4f14-87df-8f9f537a6e98︡{"d3":{"data":{"charge":-120,"directed":false,"edge_labels":false,"edge_thickness":2,"gravity":0.04,"height":null,"link_distance":50,"link_strength":1,"links":[{"color":"#aaa","curve":0,"name":"","source":0,"strength":0,"target":2},{"color":"#aaa","curve":0,"name":"","source":0,"strength":0,"target":3},{"color":"#aaa","curve":0,"name":"","source":0,"strength":0,"target":4},{"color":"#aaa","curve":0,"name":"","source":1,"strength":0,"target":2},{"color":"#aaa","curve":0,"name":"","source":1,"strength":0,"target":3},{"color":"#aaa","curve":0,"name":"","source":1,"strength":0,"target":4},{"color":"#aaa","curve":0,"name":"","source":2,"strength":0,"target":4},{"color":"#aaa","curve":0,"name":"","source":3,"strength":0,"target":4}],"loops":[],"nodes":[{"group":"0","name":"0"},{"group":"0","name":"1"},{"group":"0","name":"2"},{"group":"0","name":"3"},{"group":"0","name":"4"}],"pos":[],"vertex_labels":true,"vertex_size":7,"width":null},"viewer":"graph"}}︡{"stdout":"[0 1 0 0 1 1 0 0 0 0]\n[1 0 1 0 0 0 1 0 0 0]\n[0 1 0 1 0 0 0 1 0 0]\n[0 0 1 0 1 0 0 0 1 0]\n[1 0 0 1 0 0 0 0 0 1]\n[1 0 0 0 0 0 0 1 1 0]\n[0 1 0 0 0 0 0 0 1 1]\n[0 0 1 0 0 1 0 0 0 1]\n[0 0 0 1 0 1 1 0 0 0]\n[0 0 0 0 1 0 1 1 0 0]\n"}︡{"file":{"filename":"/projects/312b5dfd-a6ad-48f3-830b-d35eb199d477/.sage/temp/compute1-us/12045/tmp_6eCVOY.svg","show":true,"text":null,"uuid":"aeb5ed2f-a47a-4eaa-ae81-7deae1ab7cd0"},"once":false}︡{"stdout":"[1 1 0 1 0]\n[1 0 1 0 1]\n[0 1 1 0 0]\n[0 0 0 1 1]\n"}︡{"file":{"filename":"/projects/312b5dfd-a6ad-48f3-830b-d35eb199d477/.sage/temp/compute1-us/12045/tmp_1cnkF0.svg","show":true,"text":null,"uuid":"f49294b6-ff1f-4f74-bb19-eb09070fd8df"},"once":false}︡{"done":true}︡
︠5fb73d4a-71b6-4f0c-a237-da92cd1ff930︠
g = graphs.PetersenGraph()
g.show()
︡d1bdb741-75d5-499f-a391-f0d6929c5664︡{"stderr":"/ext/sage/sage-8.0/local/lib/python2.7/site-packages/matplotlib/font_manager.py:273: UserWarning: Matplotlib is building the font cache using fc-list. This may take a moment.\n  warnings.warn('Matplotlib is building the font cache using fc-list. This may take a moment.')\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-312b5dfd-a6ad-48f3-830b-d35eb199d477/178/tmp_cjaTH9.svg","show":true,"text":null,"uuid":"6e0e202e-b524-4349-a378-b2dcff4d6873"},"once":false}︡{"done":true}︡
︠4fd31b4c-e097-454e-b3cb-abfe5e004cf5︠









